$(document).ready(async function () {
  $('#txtUsuario').autocompleta(1, `JSON={ "tabela":"acesso_usuarios", "camposSelect":[ "codigo chave", "nome descricao"], "where": null}`);
  $('#btnUsuario').pesquisa('#txtUsuario', 'CODIGO', 'NOME', `/sisplan/funcoes/v1/pesquisa?JSON={"tabela":"acesso_usuarios", "camposSelect":[ "CODIGO", "NOME"]}`, 'Pesquisa Usuários', 'acesso_usuarios');
  $('#btn-Limpa-usuario').on('click', function () {
    $('#txtUsuario').val('');
  });

  function retornaBotaoOpcoes() {
    return '<div class="divBtnOpcoes">' +
      '    <button class="botaoOpcoes btn-editar" type="button" title="Editar"><span class="fas fa-edit" style="color:green"></span></button>      ' +
      '    <button class="botaoOpcoes btn-excluir" type="button" title="Excluir"><span class="fas fa-trash-alt" style="color:red"></span></button>  ' +
      '   </div>';
  }

  $('#btnConsultar').on('click', async function () {
    try {
      $.LoadingOverlay('show');
      try {
        let url = '/sisplan/funcoes/v1/pesquisa?';
        let usuario = pegaChave('#txtUsuario') != '' ? `CODIGO = '${pegaChave('#txtUsuario')}'` : '';
        const ativo = $('#txtAtivo').val() != '' ? `ATIVO = '${$('#txtAtivo').val()}'` : '';
        let params = `JSON={ "tabela": "acesso_usuarios", "camposSelect": ["CODIGO", "NOME", "EMPRESA", "TIPO", "ATIVO"], "where": ["1=1", "CODIGO <> '9999'",  "${usuario}", "${ativo}"] }`;
        let dataSetCols = [];

        let response = await requisicao('GET', url, params);

        if (!response) {
          return;
        }

        let jsonStr = await response.json();
        if (response.status != 200) {
          console.log(jsonStr.RESULT[0].mensagem);
          return;
        }

        let keys = Object.keys(jsonStr.RESULT[0][0]);

        keys.forEach(k => {
          dataSetCols.push({
            'title': k,
            'data': k
          });
        });

        dataSetCols.push({
          'title': 'OPÇÕES',
          'data': 'OPÇÕES'
        });

        dataSetCols[5].render = function () {
          return retornaBotaoOpcoes();
        };
        $('#tabelaUsuarios').DataTable({
          paging: false,
          filter: false,
          info: true,
          order: true,
          destroy: true,
          "language": {
            "sEmptyTable": "Nenhum registro encontrado",
            "sInfo": "_TOTAL_ registros",
            "sInfoEmpty": " 0 registros",
            "sInfoFiltered": "(Filtrados de _MAX_ registros)",
            "sInfoPostFix": "",
            "sInfoThousands": ".",
            "sLengthMenu": "_MENU_ resultados",
            "sLoadingRecords": "Carregando...",
            "sProcessing": "Processando...",
            "sZeroRecords": "Nenhum registro encontrado",
            "sSearch": "Pesquisar",
            "oPaginate": {
              "sNext": "Próximo",
              "sPrevious": "Anterior",
              "sFirst": "Primeiro",
              "sLast": "Último"
            },
            "oAria": {
              "sSortAscending": ": Ordenar colunas de forma ascendente",
              "sSortDescending": ": Ordenar colunas de forma descendente"
            }
          },
          "data": jsonStr.RESULT[0],
          "columns": dataSetCols
        });

        $('.btn-editar').on('click', async function () {
          try {
            window.event.preventDefault();
            let data = $('#tabelaUsuarios').DataTable().row($(this).parents('tr')).data();
            let usuarioLiberado = await liberarRegistro('ACESSO_USUARIOS', data.CODIGO);
            if (usuarioLiberado) {
              let codUsuario = btoa(data.CODIGO);
              window.location.href = `usuario/${codUsuario}`;
            }
          } catch (error) {
            console.error();
          }
        });

        $('.btn-excluir').on('click', async function () {
          let data = $('#tabelaUsuarios').DataTable().row($(this).parents('tr')).data();
          codigo = data.CODIGO;
          msgAlerta('Deseja realmente excluir esse usuário?', deletaUsuario);

          async function deletaUsuario() {
            try {
              $.LoadingOverlay('show');
              try {
                url = '/sisplan/usuario/v1/usuario?';
                params = `CODIGO=${codigo}`;

                response = await requisicao('DELETE', url, params);

                if (!response) {
                  return;
                }

                jsonStr = await response.json();

                if (response.status === 200) {

                  toastr.success(
                    'Usuário excluído com sucesso!',
                    'Confirmação', {
                    toastClass: 'alert',
                    iconClasses: {
                      error: 'alert-error',
                      info: 'alert-info',
                      success: 'alert-success',
                      warning: 'alert-warning'
                    },
                    positionClass: "toast-top-center",
                    progressBar: true,
                    timeOut: 3000,
                    fadeOut: 1000,
                    onHidden() {
                      window.location.href = `${BASE_URI}/usuario`;
                    }
                  }
                  ).css({
                    "margin-top": "20%",
                    width: "500px",
                    "max-width": "500px"
                  });
                } else {
                  msgErro(jsonStr.mensagem);
                }

              } catch (error) {
                console.error(error);
              }
            } finally {
              $.LoadingOverlay('hide');
            }
          }

        });

      } catch (error) {
        console.error(error);
      }

    } finally {
      $.LoadingOverlay('hide');
      $('#modal-filtros').modal('hide');
      atualizaTotais();
    }
  });

  function atualizaTotais() {
    let totalAtivos = 0;
    let totalBloqueados = 0;
    let valorTotal = $("#tabelaUsuarios").DataTable().rows().count();

    let array = $("#tabelaUsuarios").DataTable().rows().data();
    array.map(function (element) {
      if (element.ATIVO == "S") {
        totalAtivos++;
      }
      if (element.BLOQUEIO == "S") {
        totalBloqueados++;
      }
      return 0;
    });
    $("#txt_val_total").html(valorTotal);
    $("#txt_val_ativos").html(totalAtivos);
    $("#txt_val_bloqueados").html(totalBloqueados);
  }

  $('#btnFiltros').on('click', function () {
    $('#modal-filtros').modal('show');
  });

  $('#btnConsultar').trigger('click');

});